const KEEP_SOURCE_KEY_ID = 17;

class ConnectTool extends Tool {
    constructor(key) {
        super("Connect two nodes", "connect", key);
        this.keepSource = false;
    }

    onNodeClick(node) {
        // Is a first node selected?
        if (state.selectedItem === undefined || state.selectedItem.node === false) {
            state.setSelectedItem(node);
            return;
        }

        // Add new link
        var link = graph.addLink(state.selectedItem[NODE_ID], node[NODE_ID]);

        if (link === undefined) {
            console.error("Could not create new link");
            return;
        }

        if (this.keepSource === false) {
            // Deselect the current first node
            // TODO: Returned object not yet converted to normal one
            state.setSelectedItem(link);
        }
    }

    onBackgroundClick(event, positions) {
        state.setSelectedItem(undefined);
    }

    onKeyDown(key) {
        if (key.keyCode === KEEP_SOURCE_KEY_ID) {
            this.keepSource = true;
        }
    }

    onKeyUp(key) {
        if (key.keyCode === KEEP_SOURCE_KEY_ID) {
            this.keepSource = false;
        }
    }
}